unit main;
{
  Author Nils Wedel - nw@tshup.com
  program to control 4 stepper motor controller (by Kemo - Germany)
  TStepperMotor is a virtual motor where the main program is responsible
  to feed the parallel port.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, Menus, Buttons, ComCtrls,
  StepperMotor,cfgdlg,Shellapi;

type
  TInp32proc = function(PortAddress: short):short; stdcall;
  TOut32proc = procedure(PortAddress: short;data: short); stdcall;

  TAnimatedMotorIcon = class(TCustomControl)
  private
    TrianglePoints: array of TPoint;
    fAngle: single;
    procedure CalcTriangle(angle: single);
  public
    property Angle: single read fAngle write CalcTriangle;
    procedure Paint; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  end;

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    NewProject1: TMenuItem;
    OpenProject1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Bevel1: TBevel;
    Label1: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    ListView1: TListView;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Options1: TMenuItem;
    Parallelportsettings1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    Label3: TLabel;
    Edit3: TEdit;
    GroupBox1: TGroupBox;
    Button10: TButton;
    Button9: TButton;
    Label5: TLabel;
    Button12: TButton;
    Panel2: TPanel;
    Bevel2: TBevel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CheckBox2: TCheckBox;
    Button11: TButton;
    Button13: TButton;
    Edit4: TEdit;
    Edit5: TEdit;
    ListView2: TListView;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Edit6: TEdit;
    Button20: TButton;
    Panel3: TPanel;
    Bevel3: TBevel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    CheckBox3: TCheckBox;
    Button21: TButton;
    Button22: TButton;
    Edit7: TEdit;
    Edit8: TEdit;
    ListView3: TListView;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Edit9: TEdit;
    Button29: TButton;
    Panel4: TPanel;
    Bevel4: TBevel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    CheckBox4: TCheckBox;
    Button30: TButton;
    Button31: TButton;
    Edit10: TEdit;
    Edit11: TEdit;
    ListView4: TListView;
    Button32: TButton;
    Button33: TButton;
    Button34: TButton;
    Button35: TButton;
    Button36: TButton;
    Button37: TButton;
    Edit12: TEdit;
    Button38: TButton;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Button39: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Readme1: TMenuItem;
    HilfeDeutsch1: TMenuItem;
    N1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListView1Insert(Sender: TObject; Item: TListItem);
    procedure Button8Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button7MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button7KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button6KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure OpenProject1Click(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Parallelportsettings1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button39Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure CheckBox5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Readme1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure HilfeDeutsch1Click(Sender: TObject);
  private
    StepCounter:array[0..3] of integer;
    Motor: array[0..3] of TStepperMotor;
    MIcons: array[0..3]of TAnimatedMotorIcon;
    CurrentState: integer; // current state as one value (for port operation)
    hInOutLib: HMODULE; // handle for driver dll
    Inp32: TInp32proc; // function for reading ports
    Out32: TOut32proc; // function for writing port
    ParallelPort: short; // IO port
    CurProject: string;
    cancelReset,
    NeedApplyState: boolean;

    procedure MotorStepEvent(Mindex: integer; direction: TsmDirection);
    procedure UpdateStepCounter(Mindex, n: integer);
    procedure CmdChangeEvent(Mindex: integer);
    procedure LoadFromFile(CurProject: string);
    procedure CmdProgramFinished(Mindex: integer);
  public
    procedure ApplyState; // applies current states
  end;

var
  MainForm: TMainForm;
  AppPath: string;

implementation
const
DEG2RAD = pi/180;

{$R *.dfm}

procedure TMainForm.UpdateStepCounter(Mindex,n: integer);
begin
  inc(StepCounter[Mindex],n);

  if StepCounter[Mindex]<0 then begin
    case Mindex of
      0: begin
           Edit1.Text := IntToStr(-StepCounter[Mindex]);
           Button12.Caption := 'Left';
         end;
      1: begin
           Edit4.Text := IntToStr(-StepCounter[Mindex]);
           Button20.Caption := 'Left';
         end;
      2: begin
           Edit7.Text := IntToStr(-StepCounter[Mindex]);
           Button29.Caption := 'Left';
         end;
      3: begin
           Edit10.Text := IntToStr(-StepCounter[Mindex]);
           Button38.Caption := 'Left';
         end;
    end;
  end else begin
    case Mindex of
      0: begin
           Edit1.Text := IntToStr(StepCounter[Mindex]);
           Button12.Caption := 'Right';
         end;
      1: begin
           Edit4.Text := IntToStr(StepCounter[Mindex]);
           Button20.Caption := 'Right';
         end;
      2:begin
           Edit7.Text := IntToStr(StepCounter[Mindex]);
           Button29.Caption := 'Right';
         end;
      3:begin
           Edit10.Text := IntToStr(StepCounter[Mindex]);
           Button38.Caption := 'Right';
         end;
    end;
  end;
end;

procedure TMainForm.MotorStepEvent(Mindex:integer; direction: TsmDirection);
var n: integer;
begin
  if direction = smRight then begin
    MIcons[Mindex].angle := MIcons[Mindex].angle -6;
    //MIcons[Mindex].Paint;
    n:=1;
  end else if direction = smLeft then begin
    MIcons[Mindex].angle := MIcons[Mindex].angle +6;
    //MIcons[Mindex].Paint;
    n:=-1;
  end else exit;
  if not Motor[Mindex].IsExecuting then UpdateStepCounter(Mindex,n);
  NeedApplyState:=true;
  ApplyState;
end;

procedure TMainForm.CmdChangeEvent(Mindex: integer);
begin
  case Mindex of
  0: ListView1.Selected := ListView1.Items[Motor[0].CurrentCommand];
  1: ListView2.Selected := ListView2.Items[Motor[1].CurrentCommand];
  2: ListView3.Selected := ListView3.Items[Motor[2].CurrentCommand];
  3: ListView4.Selected := ListView4.Items[Motor[3].CurrentCommand];
  end;
end;

procedure TMainForm.CmdProgramFinished(Mindex: integer);
begin
  if CheckBox5.Checked then begin
    case Mindex of
    0: Motor[1].StartProgram(0);
    1: Motor[2].StartProgram(0);
    2: Motor[3].StartProgram(0);
    3: if CheckBox6.Checked then Motor[0].StartProgram(0);
    end;
  end;

  CheckBox5.Enabled := not (Motor[0].IsExecuting or Motor[1].IsExecuting or Motor[2].IsExecuting or Motor[3].IsExecuting);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i: integer; d: double;
begin
  AppPath:= ExtractFilePath(Application.ExeName);
  DecimalSeparator := '.';
  ThousandSeparator := ',';
  d:=0;

  cancelReset:=true;

  for i:=0 to 3 do begin
    Motor[i] := TStepperMotor.Create(i);
    Motor[i].OnStep := MotorStepEvent;
    Motor[i].OnCmdChange := CmdChangeEvent;
    Motor[i].OnProgramFinished := CmdProgramFinished;
    MIcons[i]:= TAnimatedMotorIcon.Create(self);
    StepCounter[i]:=0;
    d:=d+Motor[i].Timer.CpuFreq;
  end;
  d:=d*0.25;
  for i:=0 to 3 do begin
    Motor[i].Timer.CpuFreq:=d;
  end;

  Motor[0].StepLabel := speedbutton1; // Label21;
  Motor[1].StepLabel := speedbutton2;
  Motor[2].StepLabel := speedbutton3;
  Motor[3].StepLabel := speedbutton4;

  Panel1.InsertControl(MIcons[0]);
  Panel2.InsertControl(MIcons[1]);
  Panel3.InsertControl(MIcons[2]);
  Panel4.InsertControl(MIcons[3]);

  ParallelPort:=$378;
  CurProject:=AppPath + 'default.smp';
  LoadFromFile(CurProject);
  CurProject:='';

  Caption := 'Stepper';

  hInOutLib := LoadLibrary('inpout32.dll');
  if hInOutLib=0 then begin
    Application.MessageBox('Could not load inpout32.dll. This Application won''t be able to access the parallel port','Stepper error',0);
  end else begin
    Inp32:= GetProcAddress(hInOutLib,'Inp32');
    Out32:= GetProcAddress(hInOutLib,'Out32');
    Out32(ParallelPort+1,$00);
    Out32(ParallelPort+2,$00);
  end;

  i:=GetWindowLong(Edit1.Handle,GWL_STYLE);
  SetWindowLong(Edit1.Handle,GWL_STYLE,i or ES_NUMBER or ES_RIGHT or ES_MULTILINE);
  SetWindowLong(Edit4.Handle,GWL_STYLE,i or ES_NUMBER or ES_RIGHT or ES_MULTILINE);
  SetWindowLong(Edit7.Handle,GWL_STYLE,i or ES_NUMBER or ES_RIGHT or ES_MULTILINE);
  SetWindowLong(Edit10.Handle,GWL_STYLE,i or ES_NUMBER or ES_RIGHT or ES_MULTILINE);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Motor[0].Stop;
  Motor[1].Stop;
  Motor[2].Stop;
  Motor[3].Stop;
  Motor[0].Free;
  Motor[1].Free;
  Motor[2].Free;
  Motor[3].Free;
  if hInOutLib<>0 then FreeLibrary(hInOutLib);
end;

// feeds the parallel port with bits
procedure TMainForm.ApplyState;
begin
  if @Out32=nil then exit;
  CurrentState := Motor[0].State
               or(Motor[1].State shl 2)
               or(Motor[2].State shl 4)
               or(Motor[3].State shl 6);
  Out32(ParallelPort,$ff00 + CurrentState);
  NeedApplyState:=false;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var LW: TListView;
begin
  case TButton(Sender).Tag of
   0: begin
        LW:=ListView1;
        with LW.Items.Add do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add( edit1.text);
          SubItems.Add( edit2.text);
          SubItems.Add( Button12.Caption);
          SubItems.Add( edit3.text);
        end;
        with Motor[0].StepProgram.Add^ do begin
          Steps:= StrToIntDef(edit1.text,0);
          Frequency:= StrToFloatDef(edit2.text,0);
          RampTime:=  StrToFloatDef(edit3.text,0);
          if Button12.Caption = 'Right' then Direction:=smRight
          else if Button12.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
        StepCounter[0]:=0;
      end;
   1: begin
        LW:=ListView2;
        with LW.Items.Add do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add( edit4.text);
          SubItems.Add( edit5.text);
          SubItems.Add( Button20.Caption);
          SubItems.Add( edit6.text);
        end;
        with Motor[1].StepProgram.Add^ do begin
          Steps:= StrToIntDef(edit4.text,0);
          Frequency:= StrToFloatDef(edit5.text,0);
          RampTime:=  StrToFloatDef(edit6.text,0);
          if Button20.Caption = 'Right' then Direction:=smRight
          else if Button20.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
        StepCounter[1]:=0;
      end;
   2: begin
        LW:=ListView3;
        with LW.Items.Add do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add( edit7.text);
          SubItems.Add( edit8.text);
          SubItems.Add( Button29.Caption);
          SubItems.Add( edit9.text);
        end;
        with Motor[2].StepProgram.Add^ do begin
          Steps:= StrToIntDef(edit7.text,0);
          Frequency:= StrToFloatDef(edit8.text,0);
          RampTime:=  StrToFloatDef(edit9.text,0);
          if Button29.Caption = 'Right' then Direction:=smRight
          else if Button29.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
        StepCounter[2]:=0;
      end;
   3: begin
        LW:=ListView4;
        with LW.Items.Add do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add( edit10.text);
          SubItems.Add( edit11.text);
          SubItems.Add( Button38.Caption);
          SubItems.Add( edit12.text);
        end;
        with Motor[3].StepProgram.Add^ do begin
          Steps:= StrToIntDef(edit10.text,0);
          Frequency:= StrToFloatDef(edit11.text,0);
          RampTime:=  StrToFloatDef(edit12.text,0);
          if Button38.Caption = 'Right' then Direction:=smRight
          else if Button38.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
        StepCounter[3]:=0;
      end;
   end;
end;

procedure Resort(listview: TListView);
var i: integer;
begin
  with ListView.Items do begin
    for i:=0 to Count-1 do begin
      Item[i].Caption := IntToStr(i+1);
    end;
  end;
end;

procedure TMainForm.ListView1Insert(Sender: TObject; Item: TListItem);
begin
  Resort(TListView(Item.ListView));
end;

procedure TMainForm.Button8Click(Sender: TObject);
var n: integer; ListView: TListView;
begin
  case TButton(Sender).Tag of
    1: ListView:=ListView2;
    2: ListView:=ListView3;
    3: ListView:=ListView4;
    else ListView:=ListView1;
  end;
  with ListView do begin
    if Selected=nil then exit;
    n:=Selected.Index;
    Selected.Delete;
    Selected :=Items[n];
  end;
  ReSort(ListView);

  Motor[TButton(Sender).Tag].StepProgram.Delete(n);
end;

procedure TMainForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  case TListView(Sender).Tag of
   0: begin
        Edit1.Text := Item.SubItems[0];
        Edit2.Text := Item.SubItems[1];
        Button12.Caption := Item.SubItems[2];
        Edit3.Text := Item.SubItems[3];
      end;
   1: begin
        Edit4.Text := Item.SubItems[0];
        Edit5.Text := Item.SubItems[1];
        Button20.Caption := Item.SubItems[2];
        Edit6.Text := Item.SubItems[3];
      end;
   2: begin
        Edit7.Text := Item.SubItems[0];
        Edit8.Text := Item.SubItems[1];
        Button29.Caption := Item.SubItems[2];
        Edit9.Text := Item.SubItems[3];
      end;
   3: begin
        Edit10.Text := Item.SubItems[0];
        Edit11.Text := Item.SubItems[1];
        Button38.Caption := Item.SubItems[2];
        Edit12.Text := Item.SubItems[3];
      end;
  end;
end;

{ TAnimatedMotorIcon }
procedure TAnimatedMotorIcon.CalcTriangle(angle: single);
var a,r,o: single;
begin
  fangle:= round(angle);
  while fAngle>360 do fAngle:=fAngle-360;
  while fAngle < 0 do fAngle:=fAngle+360;
  r:= Width/2 -0.66;
  o:= r+0.5;
  a:= (fangle+60)*DEG2RAD;
  TrianglePoints[0].X := round(r*sin(a) + o);
  TrianglePoints[0].Y := round(r*cos(a) + o);
  a:= (fangle+180)*DEG2RAD;
  TrianglePoints[1].X := round(r*sin(a) + o);
  TrianglePoints[1].Y := round(r*cos(a) + o);
  a:= (fangle+300)*DEG2RAD;
  TrianglePoints[2].X := round(r*sin(a) + o);
  TrianglePoints[2].Y := round(r*cos(a) + o);
  //Paint;
  Invalidate;
end;

constructor TAnimatedMotorIcon.Create(AOwner: TComponent);
begin
  inherited;
  DoubleBuffered := true;
  SetLength(TrianglePoints,3);
  Top := 4;
  Left := 100;
  Width := 23;
  Height := 23;
  CalcTriangle(0);
end;

destructor TAnimatedMotorIcon.Destroy;
begin
  SetLength(TrianglePoints,0);
  inherited;
end;

procedure TAnimatedMotorIcon.Paint;
var rect: TRect;
begin
  rect:=GetClientRect;
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := clGray;//clInfoBk;
  Canvas.Brush.Style := bsSolid;
  Canvas.Ellipse(rect);
  Canvas.Brush.Color := clInfoBk;
  Canvas.Polygon(TrianglePoints);
end;

procedure TMainForm.Button6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Motor[TButton(Sender).Tag].Step(smRight);
  Motor[TButton(Sender).Tag].Rotate(smRight);
end;

procedure TMainForm.Button6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Motor[TButton(Sender).Tag].Stop;
end;

procedure TMainForm.Button7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Motor[TButton(Sender).Tag].Step(smLeft);
  Motor[TButton(Sender).Tag].Rotate(smLeft);
end;

procedure TMainForm.Button7MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    Motor[TButton(Sender).Tag].Stop;
end;

procedure TMainForm.Button7KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then begin
    Motor[TButton(Sender).Tag].Step(smLeft);
  end;
end;

procedure TMainForm.Button6KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then begin
    Motor[TButton(Sender).Tag].Step(smRight);
  end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  Application.MessageBox(' Stepper software - Kemo - Germany','About',0);
end;

procedure TMainForm.Button12Click(Sender: TObject);
begin
  with TButton(Sender) do begin
    if Caption = 'Right' then begin
      Caption := 'Left';
    end else
    if Caption = 'Left' then begin
      Caption := 'Pause';
    end else begin
      Caption := 'Right';
    end;
  end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  CheckBox5.Enabled := false;
  Motor[TButton(Sender).Tag].StartProgram(0);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  Motor[TButton(Sender).Tag].Stop;
  CheckBox5.Enabled := not (Motor[0].IsExecuting or Motor[1].IsExecuting or Motor[2].IsExecuting or Motor[3].IsExecuting);
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
  case TCheckBox(Sender).Tag of
  0: Motor[0].StepProgram.IsLooping := CheckBox1.Checked;
  1: Motor[1].StepProgram.IsLooping := CheckBox2.Checked;
  2: Motor[2].StepProgram.IsLooping := CheckBox3.Checked;
  3: Motor[3].StepProgram.IsLooping := CheckBox4.Checked;
  end;
end;

procedure TMainForm.Save1Click(Sender: TObject);
var i,j: integer;
  S: TStringList;
begin
  if CurProject='' then begin
    SaveAs1Click(Sender);
    exit;
  end;
  S:= TStringList.Create;
  S.Add(format('Port = %x',[ParallelPort]));
  for j:=0 to 3 do begin
    S.Add(format('[Motor_program_%d]',[j+1]));
    S.Add(format('normal_frequency = %f',[Motor[j].ControlFrequency]));
    S.Add(format('max_frequency = %f',[Motor[j].MaxFrequency]));
    if Motor[j].ResetDirection = smLeft then S.Add('resetdirection = left')
    else S.Add('resetdirection = right');
    if Motor[j].StepProgram.IsLooping then S.Add('looping = 1')
    else S.Add('looping = 0');
    with Motor[j].StepProgram do begin
      for i:=0 to count-1 do with Items[i] do begin
        case Direction of
          smRight: S.Add(format('Steps = %d %f %f right',[Steps,Frequency,RampTime]));
          smLeft: S.Add(format('Steps = %d %f %f left',[Steps,Frequency,RampTime]));
          else S.Add(format('Steps = %d %f %f none',[Steps,Frequency,RampTime]));
        end;
      end;
    end;
  end;
  S.SaveToFile(CurProject);
  S.Free;
end;

procedure TMainForm.SaveAs1Click(Sender: TObject);
var D: TSaveDialog;
begin
  D:=TSaveDialog.Create(self);
  D.DefaultExt := 'smp'; // step motor program
  D.Filter := 'step motor program (*.smp)|*.smp';
  if D.Execute then begin
    CurProject := D.FileName;
    Caption := 'Stepper - '+ CurProject;
    Save1Click(Self);
  end;
end;

procedure TMainForm.Button5Click(Sender: TObject);
var n: integer; LW: TListView;
begin
  case TButton(Sender).Tag of
    1: LW:=ListView2;
    2: LW:=ListView3;
    3: LW:=ListView4;
    else LW:=ListView1;
  end;

  with LW do begin
    if Selected=nil then exit;
    n:=Selected.Index;
  end;

  case TButton(Sender).Tag of
   0: begin
        with LW.Items[n] do begin
          //Caption := IntToStr(LW.Items.Count);
          SubItems[0]:= edit1.text;
          SubItems[1]:= edit2.text;
          SubItems[2]:= Button12.Caption;
          SubItems[3]:= edit3.text;
        end;
        with Motor[0].StepProgram.Items[n] do begin
          Steps:= StrToIntDef(edit1.text,0);
          Frequency:= StrToFloatDef(edit2.text,0);
          RampTime:=  StrToFloatDef(edit3.text,0);
          if Button12.Caption = 'Right' then Direction:=smRight
          else if Button12.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
   1: begin
        with LW.Items[n] do begin
          //Caption := IntToStr(LW.Items.Count);
          SubItems[0]:= edit4.text;
          SubItems[1]:= edit5.text;
          SubItems[2]:= Button20.Caption;
          SubItems[3]:= edit6.text;
        end;
        with Motor[1].StepProgram.Items[n] do begin
          Steps:= StrToIntDef(edit4.text,0);
          Frequency:= StrToFloatDef(edit5.text,0);
          RampTime:=  StrToFloatDef(edit6.text,0);
          if Button20.Caption = 'Right' then Direction:=smRight
          else if Button20.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
   2: begin
        with LW.Items[n] do begin
          //Caption := IntToStr(LW.Items.Count);
          SubItems[0]:= edit7.text;
          SubItems[1]:= edit8.text;
          SubItems[2]:= Button29.Caption;
          SubItems[3]:= edit9.text;
        end;
        with Motor[2].StepProgram.Items[n] do begin
          Steps:= StrToIntDef(edit7.text,0);
          Frequency:= StrToFloatDef(edit8.text,0);
          RampTime:=  StrToFloatDef(edit9.text,0);
          if Button29.Caption = 'Right' then Direction:=smRight
          else if Button29.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
   3: begin
        with LW.Items[n] do begin
          //Caption := IntToStr(LW.Items.Count);
          SubItems[0]:= edit10.text;
          SubItems[1]:= edit11.text;
          SubItems[2]:= Button38.Caption;
          SubItems[3]:= edit12.text;
        end;
        with Motor[3].StepProgram.Items[n] do begin
          Steps:= StrToIntDef(edit10.text,0);
          Frequency:= StrToFloatDef(edit11.text,0);
          RampTime:=  StrToFloatDef(edit12.text,0);
          if Button38.Caption = 'Right' then Direction:=smRight
          else if Button38.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
  end;
end;

procedure TMainForm.OpenProject1Click(Sender: TObject);
var D: TOpenDialog;

begin
  D:=TOpenDialog.Create(self);
  D.DefaultExt := 'smp'; // step motor program
  D.Filter := 'step motor program (*.smp)|*.smp';
  if D.Execute then begin
    CurProject := D.FileName;
    if not FileExists(CurProject) then begin
      CurProject:='';
      Caption := 'Stepper';
      D.Free;
      exit;
    end;
    LoadFromFile(CurProject);
  end;
  D.Free;
end;

function HexToIntDef(S: string; def: integer):integer;
var i,n: integer;
begin
  result:=0;
  n:=0;
  for i:=1 to Length(S) do begin
    case S[i] of
    'A'..'F': n:= byte(S[i]) - byte('A') +10;
    'a'..'f': n:= byte(S[i]) - byte('a') +10;
    '0'..'9': n:= byte(S[i]) - byte('0');
    else begin
      result:=def;
      exit;
    end;end;
    result := (result shl 4) + n;
  end;
end;

procedure TMainForm.LoadFromFile(CurProject: string);
var
 ListView: TListView;
 S: TStringList;
 i,j,k,n,M: integer;
 P: PChar;
 C: array[0..7,0..255]of char;
begin
    Caption := 'Stepper - '+ CurProject;
    ListView := ListView1;
    M:=0;
    S:= TStringList.Create;
    S.LoadFromFile(CurProject);
    for j:=0 to S.Count-1 do begin
      P:=PChar(S[j]);
      i:=0; n:=0;
      while true do begin
        k:=0;
        while (P[n]<>#0)and((P[n]=' ')or(P[n]='='))do inc(n);
        if P[n]=#0 then break;
        while (P[n]<>#0)and(P[n]<>' ')and(P[n]<>'=')do begin
          C[i,k] := P[n];
          inc(k);
          inc(n);
        end;
        C[i,k] := #0;
        if k>0 then inc(i);
        if P[n]=#0 then break;
      end;
      if i=0 then continue;
      if C[0]='Steps' then begin
        if i<4 then continue;
        with Motor[M].StepProgram.Add^ do begin
          Steps := StrToIntDef(C[1],0);
          Frequency := StrToFloatDef(C[2],1);
          RampTime := StrToFloatDef(C[3],0);

          with ListView.Items.Add do begin
            Caption:='0';
            SubItems.Add(IntToStr(Steps));
            SubItems.Add(format('%f',[Frequency]));
            case C[4,0] of
              'r': begin
                     Direction := smRight;
                     SubItems.Add('Right');
                   end;
              'l': begin
                     Direction := smLeft;
                     SubItems.Add('Left');
                   end;
              else begin
                Direction := smNone;
                SubItems.Add('None');
              end;
            end;
            SubItems.Add(format('%f',[RampTime]));
          end;
        end;
      end else
      if C[0]='normal_frequency' then begin
        if i>1 then Motor[M].ControlFrequency := StrToFloatDef(C[1],10);
      end else
      if C[0]='max_frequency' then begin
        if i>1 then Motor[M].MaxFrequency := StrToFloatDef(C[1],1000);
      end else
      if C[0]='looping' then begin
        if i>1 then Motor[M].StepProgram.IsLooping := StrToIntDef(C[1],0)<>0;
      end else
      if C[0]='resetdirection' then begin
        if i>1 then if C[1,0] = 'l' then Motor[M].ResetDirection := smLeft
        else Motor[M].ResetDirection := smRight;
      end else
      if C[0]='[Motor_program_1]' then begin
        ListView := ListView1;
        M:=0;
      end else
      if C[0]='[Motor_program_2]' then begin
        ListView := ListView2;
        M:=1;
      end else
      if C[0]='[Motor_program_3]' then begin
        ListView := ListView3;
        M:=2;
      end else
      if C[0]='[Motor_program_4]' then begin
        ListView := ListView4;
        M:=3;
      end;
      if C[0]='Port' then begin
        if i>1 then ParallelPort := HexToIntDef(C[1],$378);
      end;
    end;
    S.Free;
    CheckBox1.Checked := Motor[0].StepProgram.IsLooping;
    CheckBox2.Checked := Motor[1].StepProgram.IsLooping;
    CheckBox3.Checked := Motor[2].StepProgram.IsLooping;
    CheckBox4.Checked := Motor[3].StepProgram.IsLooping;
    Resort(Listview1);
    Resort(Listview2);
    Resort(Listview3);
    Resort(Listview4);

end;

procedure TMainForm.NewProject1Click(Sender: TObject);
begin
  CurProject:='';
  Caption := 'Stepper';
  ListView1.Clear;
  ListView2.Clear;
  ListView3.Clear;
  ListView4.Clear;
  Motor[0].StepProgram.Clear;
  Motor[1].StepProgram.Clear;
  Motor[2].StepProgram.Clear;
  Motor[3].StepProgram.Clear;
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
  CheckBox5.Enabled := false;
  if CheckBox5.Checked then begin
    Motor[0].StartProgram(0);
  end else begin
    Motor[0].StartProgram(0);
    Motor[1].StartProgram(0);
    Motor[2].StartProgram(0);
    Motor[3].StartProgram(0);
  end;
end;

procedure TMainForm.Button10Click(Sender: TObject);
begin
  Motor[0].Stop;
  Motor[1].Stop;
  Motor[2].Stop;
  Motor[3].Stop;
  CheckBox5.Enabled := true;
end;

procedure TMainForm.Parallelportsettings1Click(Sender: TObject);
var D: TsConfigDlg;
begin
  D:= TsConfigDlg.Create(self);
  D.Edit1.Text := IntToHex(ParallelPort,4);
  D.Edit2.Text := format('%.0f',[Motor[0].MaxFrequency]);
  D.Edit3.Text := format('%.0f',[Motor[0].ControlFrequency]);
  D.Edit4.Text := format('%.0f',[Motor[1].MaxFrequency]);
  D.Edit5.Text := format('%.0f',[Motor[1].ControlFrequency]);
  D.Edit6.Text := format('%.0f',[Motor[2].MaxFrequency]);
  D.Edit7.Text := format('%.0f',[Motor[2].ControlFrequency]);
  D.Edit8.Text := format('%.0f',[Motor[3].MaxFrequency]);
  D.Edit9.Text := format('%.0f',[Motor[3].ControlFrequency]);

  if Motor[0].ResetDirection = smLeft then D.RadioButton5.Checked := true
  else D.RadioButton6.Checked := true;
  if Motor[1].ResetDirection = smLeft then D.RadioButton7.Checked := true
  else D.RadioButton8.Checked := true;
  if Motor[2].ResetDirection = smLeft then D.RadioButton9.Checked := true
  else D.RadioButton10.Checked := true;
  if Motor[3].ResetDirection = smLeft then D.RadioButton11.Checked := true
  else D.RadioButton12.Checked := true;

  case ParallelPort of
    $378: D.RadioButton1.Checked:=true;
    $278: D.RadioButton2.Checked:=true;
    $3BC: D.RadioButton3.Checked:=true;
    else begin
      Edit1.Enabled:=true;
      D.RadioButton4.Checked:=true;
    end;
  end;

  if D.ShowModal = mrOk then begin
    if D.RadioButton1.Checked then ParallelPort := $378
    else if D.RadioButton2.Checked then ParallelPort := $278
    else if D.RadioButton3.Checked then ParallelPort := $3BC
    else ParallelPort := HexToIntDef(D.Edit1.Text,$378);
    Motor[0].MaxFrequency     := StrToFloatDef(D.Edit2.Text,1000);
    Motor[0].ControlFrequency := StrToFloatDef(D.Edit3.Text,20);
    Motor[1].MaxFrequency     := StrToFloatDef(D.Edit4.Text,1000);
    Motor[1].ControlFrequency := StrToFloatDef(D.Edit5.Text,20);
    Motor[2].MaxFrequency     := StrToFloatDef(D.Edit6.Text,1000);
    Motor[2].ControlFrequency := StrToFloatDef(D.Edit7.Text,20);
    Motor[3].MaxFrequency     := StrToFloatDef(D.Edit8.Text,1000);
    Motor[3].ControlFrequency := StrToFloatDef(D.Edit9.Text,20);

    if D.RadioButton5.Checked then Motor[0].ResetDirection := smLeft
    else Motor[0].ResetDirection := smRight;
    if D.RadioButton7.Checked then Motor[1].ResetDirection := smLeft
    else Motor[1].ResetDirection := smRight;
    if D.RadioButton9.Checked then Motor[2].ResetDirection := smLeft
    else Motor[2].ResetDirection := smRight;
    if D.RadioButton11.Checked then Motor[3].ResetDirection := smLeft
    else Motor[3].ResetDirection := smRight;

  end;
  D.Release;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var n: integer; LW: TListView;
begin
  case TButton(Sender).Tag of
    1: LW:=ListView2;
    2: LW:=ListView3;
    3: LW:=ListView4;
    else LW:=ListView1;
  end;

  with LW do begin
    if Selected=nil then exit;
    n:=Selected.Index;
  end;

  case TButton(Sender).Tag of
   0: begin
        with LW.Items.Insert(n) do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add(edit1.text);
          SubItems.Add(edit2.text);
          SubItems.Add(Button12.Caption);
          SubItems.Add(edit3.text);
        end;
        with Motor[0].StepProgram.Insert(n)^ do begin
          Steps:= StrToIntDef(edit1.text,0);
          Frequency:= StrToFloatDef(edit2.text,0);
          RampTime:=  StrToFloatDef(edit3.text,0);
          if Button12.Caption = 'Right' then Direction:=smRight
          else if Button12.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
   1: begin
        with LW.Items.Insert(n) do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add(edit4.text);
          SubItems.Add(edit5.text);
          SubItems.Add(Button20.Caption);
          SubItems.Add(edit6.text);
        end;
        with Motor[1].StepProgram.Insert(n)^ do begin
          Steps:= StrToIntDef(edit4.text,0);
          Frequency:= StrToFloatDef(edit5.text,0);
          RampTime:=  StrToFloatDef(edit6.text,0);
          if Button20.Caption = 'Right' then Direction:=smRight
          else if Button20.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
   2: begin
        with LW.Items.Insert(n) do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add(edit7.text);
          SubItems.Add(edit8.text);
          SubItems.Add(Button29.Caption);
          SubItems.Add(edit9.text);
        end;
        with Motor[2].StepProgram.Insert(n)^ do begin
          Steps:= StrToIntDef(edit7.text,0);
          Frequency:= StrToFloatDef(edit8.text,0);
          RampTime:=  StrToFloatDef(edit9.text,0);
          if Button29.Caption = 'Right' then Direction:=smRight
          else if Button29.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
   3: begin
        with LW.Items.Insert(n) do begin
          Caption := IntToStr(LW.Items.Count);
          SubItems.Add(edit10.text);
          SubItems.Add(edit11.text);
          SubItems.Add(Button38.Caption);
          SubItems.Add(edit12.text);
        end;
        with Motor[3].StepProgram.Insert(n)^ do begin
          Steps:= StrToIntDef(edit10.text,0);
          Frequency:= StrToFloatDef(edit11.text,0);
          RampTime:=  StrToFloatDef(edit12.text,0);
          if Button38.Caption = 'Right' then Direction:=smRight
          else if Button38.Caption = 'Left' then Direction:=smLeft
          else Direction:=smNone;
        end;
      end;
  end;
end;

procedure TMainForm.Button39Click(Sender: TObject);
var i,t,n: integer; c: cardinal;
  m: single;
  b: array[0..3] of boolean;
begin
  if @Inp32=nil then exit;

  cancelReset:= not cancelReset;
  if cancelReset then exit;
  Button39.Caption := 'Cancel';
  cancelReset:=false;


  m:=1000;
  for i:=0 to 3 do begin
    Motor[i].Stop;
    if (Motor[i].MaxFrequency>0) and (m>Motor[i].MaxFrequency) then m:=Motor[i].MaxFrequency;
    b[i]:=true;
  end;

  t:=round(800/m);

  c:=GetTickCount;
  while b[0] or b[1] or b[2] or b[3] do begin
    n:=Inp32(ParallelPort+1);
    if (n and $0040)>0 then b[0]:=false; // status-6 pin10        40
    if (n and $0020)>0 then b[1]:=false; // status-5 pin12        20
    if (n and $0010)>0 then b[2]:=false; // status-4 pin13        10
    if (n and $0008)>0 then b[3]:=false; // status-3 pin15        08
    for i:=0 to 3 do begin
      if b[i] then Motor[i].Step( Motor[i].ResetDirection );
    end;
    if GetTickCount-c > 10000 then begin
      Application.MessageBox('Reset time exceeded (10 seconds)','Warning',0);
      break;
    end;
    Application.ProcessMessages;
    if cancelReset then break;
    Sleep(t);
  end;

  for i:=0 to 3 do begin
    Motor[i].StepCount := 0;
    Motor[i].StepLabel.Caption := 'X';
  end;

  MIcons[0].Angle := 0;
  MIcons[1].Angle := 0;
  MIcons[2].Angle := 0;
  MIcons[3].Angle := 0;

  cancelReset:= true;
  CheckBox5.Enabled := true;
  Button39.Caption := 'Reset';
end;

procedure TMainForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  #0..#31,'0'..'9','-','.':;
  else Key := #0;
  end;
end;

procedure TMainForm.CheckBox5Click(Sender: TObject);
begin
  CheckBox6.Enabled  := CheckBox5.Checked;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  TSpeedButton(Sender).Caption := '0';
  Motor[TSpeedButton(Sender).Tag].StepCount := 0;
  MIcons[TSpeedButton(Sender).Tag].Angle := 0;
  StepCounter[TSpeedButton(Sender).Tag] := 0;

  Edit1.Text := IntToStr(StepCounter[0]);
  Edit4.Text := IntToStr(StepCounter[1]);
  Edit7.Text := IntToStr(StepCounter[2]);
  Edit10.Text := IntToStr(StepCounter[3]);
end;

procedure TMainForm.Readme1Click(Sender: TObject);
begin
  if 32 >= ShellExecute(handle,'open','readme.html',nil,PChar(AppPath),SW_SHOW) then begin
    ShellExecute(handle,'open','readme.txt',nil,PChar(AppPath),SW_SHOW);
  end;
end;

procedure TMainForm.Help2Click(Sender: TObject);
begin
  if 32 >= ShellExecute(handle,'open','help.html',nil,PChar(AppPath),SW_SHOW) then begin
    ShellExecute(handle,'open','help.txt',nil,PChar(AppPath),SW_SHOW);
  end;
end;

procedure TMainForm.HilfeDeutsch1Click(Sender: TObject);
begin
  if 32 >= ShellExecute(handle,'open','help_german.html',nil,PChar(AppPath),SW_SHOW) then begin
    ShellExecute(handle,'open','help_german.txt',nil,PChar(AppPath),SW_SHOW);
  end;
end;

end.
